﻿Imports System.Media
Imports System.Diagnostics
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Windows.Threading

Class Player

    'Controller
    Dim controller As Controller

    Dim tmrSeeker As DispatcherTimer

    'Fenster schließen
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnClose.Click
        Me.Close()
    End Sub


    Private Sub tick()
        sdrSeeker.Value = controller.Position
    End Sub

    Private Sub frmPlayer_Drop(ByVal sender As Object, ByVal e As System.Windows.DragEventArgs) Handles frmPlayer.Drop
        controller.DropFiles(e)

        controller.updatePlaylistSource()
    End Sub

    'Alles nötige initialisieren
    Private Sub frmPlayer_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles frmPlayer.Loaded
        controller = controller.instance(Me)

        tmrSeeker = New DispatcherTimer
        tmrSeeker.Interval = TimeSpan.FromMilliseconds(1000)
        AddHandler tmrSeeker.Tick, AddressOf tick
        tmrSeeker.Start()
    End Sub


    Private Sub btnClose_Unloaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnClose.Unloaded
        controller.unload()
    End Sub


    'Fenster bei bedarf verschieben
    Private Sub frmPlayer_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles frmPlayer.MouseDown
        Dim p = e.GetPosition(Me)

        If p.X <= 50 And e.LeftButton = MouseButtonState.Pressed Then
            Me.DragMove()
        End If
    End Sub


    'Mauszeiger anpassen, wenn er sich im Bereich befindet,
    'wo das Fenster verschoben wird
    Private Sub frmPlayer_MouseMove( _
        ByVal sender As Object, _
        ByVal e As System.Windows.Input.MouseEventArgs) Handles frmPlayer.MouseMove

        Dim p = e.GetPosition(Me)

        If p.X <= 50 Then
            If Me.Cursor Is Nothing Then
                Me.Cursor = Cursors.Hand
            End If
        Else
            If Not Me.Cursor Is Nothing Then
                Me.Cursor = Nothing
            End If
        End If
    End Sub


    'Abspielen
    Private Sub btnPlay_Click( _
        ByVal sender As Object, _
        ByVal e As System.Windows.RoutedEventArgs) Handles btnPlay.Click

        If controller.isPlaying Then
            controller.Pause()
        Else
            controller.Play()
        End If

    End Sub

    Sub changePlayStatus(ByVal prop As Boolean)
        changeStatus(imgPlay, Not prop, "Knob%20Play.png", "Knob%20Pause.png")
    End Sub

    Sub changeStatus(ByVal source As Object, ByVal prop As Boolean, ByVal part1 As String, ByVal part2 As String)
        source.Source = getImageSource(IIf(prop, _
                                  "pack://application:,,/images/" & part1, _
                                  "pack://application:,,/images/" & part2))
    End Sub

    Private Function getImageSource(ByVal path As String) As ImageSource
        Dim imgConv As New ImageSourceConverter()

        Return imgConv.ConvertFromString(path)
    End Function

    Sub changeTitle(ByVal title As String)
        tbTitle.Text = title
    End Sub

    Private Sub sdrSeeker_PreviewMouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles sdrSeeker.PreviewMouseUp
        controller.Position = sdrSeeker.Value
    End Sub

    Public Sub onMediaOpened(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs)
        sdrSeeker.Maximum = controller.Maximum
    End Sub

    Private Sub mnuLibrary_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuLibrary.Click
        controller.switchLibrary()
    End Sub

    Private Sub btnForward_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnForward.Click
        controller.PlayForward()
    End Sub

    Private Sub btnBack_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnBack.Click
        controller.PlayBackward()
    End Sub

    Private Sub mnuShuffle_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuShuffle.Click
        controller.Playlist.Shuffle = mnuShuffle.IsChecked
    End Sub

    Private Sub mnuOpenFile_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuOpenFile.Click
        Dim media As Media.mediaElement
        Dim fo = New Microsoft.Win32.OpenFileDialog()
        fo.Filter = "Alle Dateien|*.mp3;*.avi;*.mpg;*.mpeg;*.wav,*.mid;*.midi;*.wav;*.wma;*.wmv"
        fo.Multiselect = True
        If fo.ShowDialog() Then

            controller.Playlist.Clear()

            For Each filename As String In fo.FileNames
                media = controller.Library.addMediaElement(filename)
                controller.Playlist.addFile(media)
            Next

            controller.Play()
        End If
    End Sub

    Private Sub mnuOpenPlaylist_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuOpenPlaylist.Click
        Dim fo = New Microsoft.Win32.OpenFileDialog()
        fo.Filter = "Alle Dateien|*.m3u;*.wpl"
        fo.Multiselect = False

        If fo.ShowDialog() Then
            controller.Playlist = Playlist.fromFile(fo.FileName)
            controller.Play()
        End If
    End Sub
End Class
